package info.textgrid.middleware;

import java.io.IOException;
import org.elasticsearch.action.get.GetRequest;
import org.elasticsearch.action.get.GetResponse;
import org.elasticsearch.client.RequestOptions;
import org.elasticsearch.common.Strings;
import org.elasticsearch.search.fetch.subphase.FetchSourceContext;
import info.textgrid.middleware.oaipmh.ListMetadataFormatsType;
import info.textgrid.middleware.oaipmh.MetadataFormatType;

/**
 *
 */
public class MetadataFormatListDelivererTG extends MetadataFormatListDelivererAbs {

  /**
   * 
   */
  public MetadataFormatListDelivererTG() {
    //
  }

  /**
   *
   */
  @Override
  public ListMetadataFormatsType setMetadataFormatList(String id) {

    String[] includes = new String[] {TGConstants.URI};
    String[] excludes = Strings.EMPTY_ARRAY;
    FetchSourceContext fetchSourceContext = new FetchSourceContext(true, includes, excludes);

    ListMetadataFormatsType lmft = new ListMetadataFormatsType();
    MetadataFormatType mft = new MetadataFormatType();
    MetadataFormatType openAireMetadataFormat = new MetadataFormatType();

    GetRequest getRequest =
        new GetRequest(this.oaiEsClient.getEsIndex(), this.oaiEsClient.getEsType(),
            id.replace("textgrid:", "")).fetchSourceContext(fetchSourceContext);

    GetResponse tgObject = null;
    try {
      tgObject = this.oaiEsClient.getEsClient().get(getRequest, RequestOptions.DEFAULT);

      if (tgObject.isExists()) {
        setIdExist(true);
        mft.setMetadataPrefix(OAIPMHUtilities.OAIDC_PREFIX);
        mft.setMetadataNamespace(OAIPMHUtilities.OAIDC_NAMESPACE);
        mft.setSchema(OAIPMHUtilities.OAIDC_SCHEMA_LOCATION);

        openAireMetadataFormat.setMetadataPrefix(OAIPMHConstants.METADATA_OPENAIRE_PREFIX);
        openAireMetadataFormat.setMetadataNamespace(OAIPMHUtilities.OPEN_AIRE_NAMESPACE);
        openAireMetadataFormat.setSchema(OAIPMHUtilities.OPEN_AIRE_SCHEMA_LOCATION);

        lmft.getMetadataFormat().add(mft);
        lmft.getMetadataFormat().add(openAireMetadataFormat);

      } else {
        setIdExist(false);
        lmft = null;
      }
    } catch (IOException e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
    }

    return lmft;
  }

  /**
   *
   */
  @Override
  public ListMetadataFormatsType setMetadataFormatList() {

    // Get things from abstract class.
    ListMetadataFormatsType result = super.setMetadataFormatList();

    // Add metadata format for IDIOM METS.
    MetadataFormatType mftIdiomMets = new MetadataFormatType();
    mftIdiomMets.setMetadataPrefix(OAIPMHConstants.METADATA_IDIOM_PREFIX);
    mftIdiomMets.setMetadataNamespace(OAIPMHUtilities.METS_NAMESPACE);
    mftIdiomMets.setSchema(OAIPMHUtilities.METS_SCHEMA_LOCATION);

    result.getMetadataFormat().add(mftIdiomMets);

    return result;
  }

}
