package info.textgrid.middleware;

import java.text.ParseException;
import org.junit.BeforeClass;
import org.junit.Ignore;
import org.junit.Test;
import info.textgrid.middleware.oaipmh.DeletedRecordType;
import info.textgrid.middleware.oaipmh.GranularityType;
import info.textgrid.middleware.common.TextGridMimetypes;

/**
 * FIXME: Add documentation how to use this class, use SSH tunnel?
 */
@Ignore
public class TestDHOAIPMHLocally {

  public static OAIPMHElasticSearchClient oaiEsClient;

  private static RecordDelivererDC record;
  private static RecordListDelivererDC recordList;
  private static IdentifierListDelivererDC identifierList;
  private static MetadataFormatListDelivererInterface metadataFormatList =
      new MetadataFormatListDelivererDH();
  private static SetListDeliverer setListDARIAH = new SetListDeliverer(false, true);

  // private static OpenAireRecord openAireRecord;
  private static RecordDelivererDATACITE recordDATACITE;
  // private static OpenAireRecordList openAireRecordList;
  private static RecordListDelivererDATACITE recordListDATACITE;
  // private static OpenAireIdentifierList openAireIdentifierList;
  private static IdentifierListDelivererDATACITE identifierListDATACITE;
  private static IDIOMImages idiomImages;
  private DeletedRecordType deletedRecordType = DeletedRecordType.NO;
  private GranularityType granularityType = GranularityType.YYYY_MM_DD_THH_MM_SS_Z;
  private RepIdentification rep = new RepIdentification("DARIAH-DE Repository",
      "https://trep.de.dariah.eu", this.deletedRecordType, "2011-06-11T02:32:40Z",
      this.granularityType, "2.0", "funk@sub.uni-goettingen.de");

  /**
   * FIXME: it should not be necessary to put idiom record variables for a DARIAH test case
   */
  private static RecordDelivererIDIOM recordIDIOM;
  private static RecordListDelivererIDIOM recordListIDIOM;
  private static IdentifierListDelivererIDIOM identifierListIDIOM =
      new IdentifierListDelivererIDIOM(true, false);

  private OAIPMHImpl request =
      new OAIPMHImpl(this.rep,
          TestDHOAIPMHLocally.record,
          TestDHOAIPMHLocally.recordIDIOM,
          TestDHOAIPMHLocally.recordDATACITE,
          TestDHOAIPMHLocally.recordList,
          TestDHOAIPMHLocally.recordListIDIOM,
          TestDHOAIPMHLocally.recordListDATACITE,
          TestDHOAIPMHLocally.metadataFormatList,
          TestDHOAIPMHLocally.setListDARIAH,
          TestDHOAIPMHLocally.identifierList,
          TestDHOAIPMHLocally.identifierListIDIOM,
          // OaiPmhTestDH.openAireIdentifierList);
          TestDHOAIPMHLocally.identifierListDATACITE,
          TestDHOAIPMHLocally.idiomImages);

  OAIPMHUtilities settings = new OAIPMHUtilities();

  /**
   * @throws Exception
   */
  @BeforeClass
  public static void setUp() throws Exception {
    int[] ports = new int[] {9202};
    oaiEsClient = new OAIPMHElasticSearchClient("localhost", ports, 100);
    oaiEsClient.setEsIndex("dariah-public");
    oaiEsClient.setEsType("metadata");

    record = new RecordDelivererDC(false, true);
    record.setOaiEsClient(oaiEsClient);
    record.setWorkFields(OAIPMHConstants.TEST_DARIAH_FIELDS);
  }

  /**
   * @throws ParseException
   */
  @Test
  public void testGetRequestIdentify() throws ParseException {
    System.out.println("Test for the verb \"Identify\" with succesfull response");
    String r = this.request.getRequest("Identify", "", "", "", "", "", "");
    System.out.println(r);
    System.out.println("-----------------------------------\n");
  }

  /**
   * @throws ParseException
   */
  @Test
  public void testGetRequestGetRecordDariah() throws ParseException {

    TestDHOAIPMHLocally.record.setContributor(OAIPMHConstants.TEST_DARIAH_CONTRIBUTOR_LIST);
    TestDHOAIPMHLocally.record.setCoverage(OAIPMHConstants.TEST_DARIAH_COVERAGE_LIST);
    TestDHOAIPMHLocally.record.setCreator(OAIPMHConstants.TEST_DARIAH_CREATOR_LIST);
    TestDHOAIPMHLocally.record.setDates(OAIPMHConstants.TEST_DARIAH_DATE_LIST);
    TestDHOAIPMHLocally.record.setDescriptions(OAIPMHConstants.TEST_DARIAH_DESCRIPTION_LIST);
    TestDHOAIPMHLocally.record.setFormats(OAIPMHConstants.TEST_DARIAH_FORMAT_LIST);
    TestDHOAIPMHLocally.record.setIdentifiers(OAIPMHConstants.TEST_DARIAH_IDENTIFIER_LIST);
    TestDHOAIPMHLocally.record.setLanguages(OAIPMHConstants.TEST_DARIAH_LANGUAGE_LIST);
    TestDHOAIPMHLocally.record.setPublishers(OAIPMHConstants.TEST_DARIAH_PUBLISHER_LIST);
    TestDHOAIPMHLocally.record.setRelations(OAIPMHConstants.TEST_DARIAH_RELATIONS_LIST);
    TestDHOAIPMHLocally.record.setRights(OAIPMHConstants.TEST_DARIAH_RIGHTS_LIST);
    TestDHOAIPMHLocally.record.setSources(OAIPMHConstants.TEST_DARIAH_SOURCE_LIST);
    TestDHOAIPMHLocally.record.setSubjects(OAIPMHConstants.TEST_DARIAH_SUBJECT_LIST);
    TestDHOAIPMHLocally.record.setTitles(OAIPMHConstants.TEST_DARIAH_TITLE_LIST);
    TestDHOAIPMHLocally.record.setTypes(OAIPMHConstants.TEST_DARIAH_TYPE_LIST);
    TestDHOAIPMHLocally.record.setFields(OAIPMHConstants.TEST_DARIAH_FIELDS);
    TestDHOAIPMHLocally.record.setFormatField(OAIPMHConstants.TEST_DARIAH_FORMAT);
    TestDHOAIPMHLocally.record.setFormatToFilter("metadata");
    TestDHOAIPMHLocally.record
        .setDateOfObjectCreation(OAIPMHConstants.TEST_DARIAH_MODIFIED_FIELD);
    TestDHOAIPMHLocally.record
        .setRepositoryObjectURIPrefix(OAIPMHConstants.TEST_DARIAH_ITEM_IDENTIFIER_PREFIX);
    TestDHOAIPMHLocally.record.setIdentifierField("administrativeMetadata.dcterms:identifier");

    System.out.println("Test for the verb \"GetRecord\" for DARIAH with succesfull response");
    String p = this.request.getRequest("GetRecord", "hdl:21.T11991/0000-0005-E1AA-D", "oai_dc", "",
        "", "", "");
    System.out.println(p);
    System.out.println("-----------------------------------\n");
  }

  /**
   * @throws ParseException
   */
  @Test
  public void testListRecordsDariah() throws ParseException {

    TestDHOAIPMHLocally.recordList.setContributors(OAIPMHConstants.TEST_DARIAH_CONTRIBUTOR_LIST);
    TestDHOAIPMHLocally.recordList.setCoverages(OAIPMHConstants.TEST_DARIAH_COVERAGE_LIST);
    TestDHOAIPMHLocally.recordList.setCreators(OAIPMHConstants.TEST_DARIAH_CREATOR_LIST);
    TestDHOAIPMHLocally.recordList.setDates(OAIPMHConstants.TEST_DARIAH_DATE_LIST);
    TestDHOAIPMHLocally.recordList.setDescriptions(OAIPMHConstants.TEST_DARIAH_DESCRIPTION_LIST);
    TestDHOAIPMHLocally.recordList.setFormats(OAIPMHConstants.TEST_DARIAH_FORMAT_LIST);
    TestDHOAIPMHLocally.recordList.setIdentifiers(OAIPMHConstants.TEST_DARIAH_IDENTIFIER_LIST);
    TestDHOAIPMHLocally.recordList.setLanguages(OAIPMHConstants.TEST_DARIAH_LANGUAGE_LIST);
    TestDHOAIPMHLocally.recordList.setPublishers(OAIPMHConstants.TEST_DARIAH_PUBLISHER_LIST);
    TestDHOAIPMHLocally.recordList.setRelations(OAIPMHConstants.TEST_DARIAH_RELATIONS_LIST);
    TestDHOAIPMHLocally.recordList.setRights(OAIPMHConstants.TEST_DARIAH_RIGHTS_LIST);
    TestDHOAIPMHLocally.recordList.setSources(OAIPMHConstants.TEST_DARIAH_SOURCE_LIST);
    TestDHOAIPMHLocally.recordList.setSubjects(OAIPMHConstants.TEST_DARIAH_SUBJECT_LIST);
    TestDHOAIPMHLocally.recordList.setTitles(OAIPMHConstants.TEST_DARIAH_TITLE_LIST);
    TestDHOAIPMHLocally.recordList.setTypes(OAIPMHConstants.TEST_DARIAH_TYPE_LIST);
    TestDHOAIPMHLocally.recordList.setFormatField(OAIPMHConstants.TEST_DARIAH_FORMAT);
    TestDHOAIPMHLocally.recordList.setDateOfObjectCreation(OAIPMHConstants.TEST_DARIAH_CREATED);
    TestDHOAIPMHLocally.recordList.setRangeField(OAIPMHConstants.TEST_DARIAH_MODIFIED_FIELD);
    TestDHOAIPMHLocally.recordList
        .setDateOfObjectCreation(OAIPMHConstants.TEST_DARIAH_RANGE_FIELD);
    TestDHOAIPMHLocally.recordList.setIdentifierField(OAIPMHConstants.TEST_DARIAH_IDENTIFIER);
    TestDHOAIPMHLocally.recordList.setFormatToFilter(TextGridMimetypes.DARIAH_COLLECTION);
    TestDHOAIPMHLocally.recordList.setModifiedField(OAIPMHConstants.TEST_DARIAH_MODIFIED_FIELD);
    TestDHOAIPMHLocally.recordList
        .setRelationToFurtherMetadataObject("descriptiveMetadata.dc:relation");
    TestDHOAIPMHLocally.recordList.setSearchResponseSize(100);

    String r = this.request.getRequest("ListRecords", "", "oai_dc", "21.T11991/0000-0003-718E-E",
        "", "", "");
    System.out.println(r);
    System.out.println("-----------------------------------\n");
  }

  /**
   * @throws ParseException
   */
  @Test
  public void testListSetsDARIAH() throws ParseException {

    TestDHOAIPMHLocally.setListDARIAH.setFormatField(OAIPMHConstants.TEST_DARIAH_FORMAT);
    TestDHOAIPMHLocally.setListDARIAH
        .setFormatToFilter(OAIPMHConstants.TEST_DARIAH_COLLECTION_MIMETYPE);
    TestDHOAIPMHLocally.setListDARIAH.setIdentifierField(OAIPMHConstants.TEST_DARIAH_IDENTIFIER);
    TestDHOAIPMHLocally.setListDARIAH
        .setRepositoryObjectURIPrefix(OAIPMHConstants.TEST_DARIAH_ITEM_IDENTIFIER_PREFIX);
    TestDHOAIPMHLocally.setListDARIAH
        .setIdentifierField("administrativeMetadata.dcterms:identifier");
    TestDHOAIPMHLocally.setListDARIAH
        .setSpecFieldPrefix(OAIPMHConstants.TEST_DARIAH_COLLECTIONREGISTRY_PREFIX);
    String r = this.request.getRequest("ListSets", "", "", "", "", "", "");
    System.out.println(r);
    System.out.println("-----------------------------------\n");
  }

  /**
   * @throws ParseException
   */
  @Test
  public void testListIdentifiersDARIAH() throws ParseException {

    TestDHOAIPMHLocally.identifierList.setFieldForRange(OAIPMHConstants.TEST_DARIAH_RANGE_FIELD);
    TestDHOAIPMHLocally.identifierList
        .setIdentifierListFields(OAIPMHConstants.TEST_DARIAH_IDENTIFIER_LIST_FIELDS);
    TestDHOAIPMHLocally.identifierList
        .setDateOfObjectCreation("administrativeMetadata.dcterms:modified");
    TestDHOAIPMHLocally.identifierList
        .setRepositoryObjectURIPrefix(OAIPMHConstants.TEST_DARIAH_ITEM_IDENTIFIER_PREFIX);
    TestDHOAIPMHLocally.identifierList
        .setIdentifierField("administrativeMetadata.dcterms:identifier");
    TestDHOAIPMHLocally.identifierList.setSearchResponseSize("100");
    String r = this.request.getRequest("ListIdentifiers", "", "oai_dc", "", "", "", "");
    System.out.println(r);
    System.out.println("-----------------------------------\n");
  }

}
